#include <iostream>
#include <iomanip>

#include <x86intrin.h>

int main()
{
#ifdef __SSE__
  {
    float __attribute__ ((aligned(16))) Q[4]={1.f,2.f,3.f,4.f};
    float __attribute__ ((aligned(16))) Z[4];
    __m128 v4Q = _mm_load_ps(Q);
    __m128 v4X = _mm_mul_ps(v4Q,v4Q);
    _mm_store_ps(Z,v4X);
    for(int i=0; i!=4; ++i)
      std::cout << " Q["<<i<<"]="<<std::setw(6)<<Q[i]
		<< " Z["<<i<<"]="<<std::setw(6)<<Z[i]<<'\n';
  }
#endif
#ifdef __AVX__
  {
    float __attribute__ ((aligned(32))) Q[8]={1.f,2.f,3.f,4.f,5.f,6.f,7.f,8.f};
    float __attribute__ ((aligned(32))) Z[8];
    __m256 v8Q = _mm256_load_ps(Q);
    __m256 v8X = _mm256_mul_ps(v8Q,v8Q);
    _mm256_store_ps(Z,v8X);
    for(int i=0; i!=8; ++i)
      std::cout << " Q["<<i<<"]="<<std::setw(6)<<Q[i]
		<< " Z["<<i<<"]="<<std::setw(6)<<Z[i]<<'\n';
  }
#else
#  warning __AVX__ not #defined: this will not test cctools as
#  warning did you compile with -march=native?
#  warning if so, does your computer support AVX instructions?
#  warning (it will if "sysctl machdep.cpu.features" has "AVX1.0)"
#endif
}
